<?php

namespace FiloBlu\Flow\Model\From\Entity;

class Product extends AbstractEntity{

    public function getObjectId(){

        if(is_null($this->_objectEntityId)){
            $this->_objectEntityId = \Magento\Framework\App\ObjectManager::getInstance()->create($this->getEntityModel())->getIdBySku( $this->_entityIdentifier);
            if(empty($this->_objectEntityId)){
                $this->_objectEntityId = false;
            }
        }

        return $this->_objectEntityId;
    }

    protected function setObjectAttributeValue(){

        if(!$this->getObjectId()){
            $message = sprintf('No id found for model %s with given identifier %s',$this->getEntityModel(),$this->_entityIdentifier);
            $this->_logger->info('ITEM SKIPPED: ' . $message);
        }

        $pids = array($this->getObjectId());
        
         // error_log(__METHOD__ . ' PRODUCT ID: '.$this->getObjectId() . ' - A: ' . $this->getAttribute()->getAttributeCode() . ' - V: ' .$this->getAttributeValue() . PHP_EOL , 3, '/var/www/html/campomaggi/var/log/eavs.log');             

        $fatherProductsIds = $this->helper_product->getParentProductsIds($pids);

        if(!empty($fatherProductsIds)){
                $pids = array_merge($pids, $fatherProductsIds);
        }

        $input_type = strtolower($this->getAttribute()->getFrontend()->getInputType());
        $attributeValue = $this->getAttributeValue();

        if(($input_type === 'multiselect' || $input_type === 'select') && $this->_storeId!=0){//Mage_Core_Model_App::ADMIN_STORE_ID){
            //MAGE-440 Controllare che se l'attributo è un dropdown e viene passato uno scope non nullo lo metta a meta processed 1 senza fare nulla.
//            throw new \Exception('Select and multi select have to be set on store view 0 only',FiloBlu_Flow_Model_From_Eavs::DROPDOWN_STORE_ERR_CODE);
        }

        if($input_type === 'multiselect' && empty($attributeValue)){
            foreach($pids as $pid){
                $_prod = $this->_product_factory->create()->load($this->getObjectId());
                $_prod->setData($this->getAttribute()->getAttributeCode(), '');
                $attributesData = array($this->getAttribute()->getAttributeCode() => '');
                if($this->getAttribute()->getAttributeCode() != 'sku'){
                    \Magento\Framework\App\ObjectManager::getInstance()->get('Magento\Catalog\Model\Product\Action')
                        ->updateAttributes($pids, $attributesData, $this->_storeId);
                    }
                $_prod->save();
            }
        } elseif(is_null($attributeValue) || empty($attributeValue)) {
            
               $_prod = $this->_product_factory->create()->load($this->getObjectId());
                $_prod->setData($this->getAttribute()->getAttributeCode(), '');
                $attributesData = array($this->getAttribute()->getAttributeCode() => '');
                if($this->getAttribute()->getAttributeCode() != 'sku'){
                    \Magento\Framework\App\ObjectManager::getInstance()->get('Magento\Catalog\Model\Product\Action')
                        ->updateAttributes($pids, $attributesData, $this->_storeId);
                    }
                $_prod->save();
                
        } else {
                
            $attributesData = array($this->getAttribute()->getAttributeCode() => $attributeValue);
            try{
                if($this->getAttribute()->getAttributeCode() != 'sku'){
                    \Magento\Framework\App\ObjectManager::getInstance()->get('Magento\Catalog\Model\Product\Action')
                        ->updateAttributes($pids, $attributesData, $this->_storeId);
                }
            }catch (\Exception $e){
                $message = "Problem while processing eavs,<br/> store id : ".$this->_storeId."<br/> pids : ".print_r($pids,true). "<br/> attribute data : ".print_r($attributesData,true);
                $message .= "<br/> \Exception : ".$e->getMessage();
                $message .= "<br/> Backtrace : <br/> ".nl2br($e->getTraceAsString());
                FiloBlu_Flow_Model_From_Eavs::sendErrorEmail($message);
                throw new \Exception($e->getMessage());
            }
        }
    }

}//End of class

